<template>
  <div id="app" class="app">
    <AppHeader />

    <main v-if="data.data">
      <AppHero :text="data.data.form_title" />

      <div class="c-page-content">
        <ExpiredForm v-if="isFormExpired(data.data.page_expiry_date)" />

        <Apply v-if="!isFormExpired(data.data.page_expiry_date)" />
      </div>
    </main>

    <div v-if="data.isError">
      <AppHero />
      <DataError />
    </div>

    <Loader v-if="data.isLoading" />

    <AppFooter />
  </div>
</template>

<script>
import AppHeader from "@/components/layouts/AppHeader";
import AppFooter from "@/components/layouts/AppFooter";
import Apply from "@/components/pages/Apply";
import { mapState } from "vuex";
import Loader from "./components/ui/Loader";
import ExpiredForm from "./components/responses/ExpiredForm";
import AppHero from "./components/layouts/AppHero";
import DataError from "./components/responses/DataError";

export default {
  name: "App",
  computed: {
    ...mapState(["data"])
  },
  components: {
    DataError,
    AppHero,
    ExpiredForm,
    Apply,
    AppFooter,
    AppHeader,
    Loader
  },
  mounted() {
    this.$store.dispatch("fetchData");
  },
  methods: {
    isFormExpired(deadline) {
      const now = new Date();
      const expireDate = new Date(deadline);

      return now.getTime() > expireDate.getTime();
    }
  }
};
</script>

<style lang="scss">
@import "assets/scss/global-style/global-style";

.app {
  display: flex;
  flex-direction: column;
  min-height: 100%;

  .b-footer {
    margin-top: auto;
  }
}
</style>
